/*
 	FetchAE.h -- sample Apple Event code for Fetch
 	
 	Copyright (c) 1996, Dartmouth College
 	Copyright (c) 2001, Fetch Softworks
 	All Rights Reserved.
 	
 	Distribution and use of this code is hereby permitted, provided that any resulting
 	work includes the copyright statement above.
*/

#define	FETCH_APP_SIGNATURE		'FTCh'

#define	kAEFetchSuite			'FTCh'
#define	kAEDownloadEvent		'Dnld'
#define	kAEViewFileEvent		'VwFi'
#define	kAEViewFileListEvent		'VwFL'
#define	kAEPutIntoEvent			'PutI'
#define	kAEFetchPutIntoItemsParam	'Itms'
#define	kAEFetchPutIntoTextFormatParam	'TFmt'
#define	kAEFetchPutIntoBinaryFormatParam	'BFmt'
#define	kAESendFTPCommandEvent		'SndC'
#define	kAEFetchSendFTPCommandsParam	'Cmds'

/* custom app properties (i.e. preferences) */
#define	pTextCreator			'pTCr'
#define	pCacheTimeout			'pCTo'
#define	pDecodeBinhex			'pBhx'
#define	pDecodeMacbin			'pMb2'
#define	pDecodeAppleSingle		'pASg'
#define	pDecodeMacHost			'pMHt'
#define	pDecodeStuffit			'pSit'
#define	pTickleServer			'pTkl'
#define	pDownloadDir			'pDDr'
#define	pUseDownloadFolder		'pUDF'
#define	pDisplayMessages		'pMgs'
#define	pUseTypeImage			'pTpI'
#define	pOmitDotFiles			'pODF'
#define	pDefaultTextFont		'pTFt'
#define	pDefaultTextFontSize		'pTFS'
#define	pDefaultTabWidth		'pTbW'
#define	pDefaultBinaryType		'pBTp'
#define	pDefaultBinaryCreator		'pBCr'
#define	pTranslateISO			'pISO'
#define	pShowSignonDialog		'pSSD'
#define	pDefaultUploadBinaryFormat	'pUBF'
#define	pDefaultIncludingText		'pDIT'
#define	pPassiveMode			'pPSV'
#define	pMinimumDataPort		'pMnP'
#define	pMaximumDataPort		'pMxP'
#define	pUseSOCKSGateway		'pSks'
#define	pSOCKSGatewayHost		'pSkH'
#define	pSOCKSGatewayPort		'pSkP'
#define pSocksVersion			'pSkV'
#define	pUseProxyServer			'pPxy'
#define	pProxyServer			'pPxS'
#define	pProxyUserid			'pPUs'
#define	pProxyPassword			'pPPw'
#define	pProxyType			'pPTy'
#define	pDontProxyDomains		'pDPD'
#define	pAutomaticDefaultToText		'pAuT'
#define	pMaxCacheSize			'pMCS'
#define	pOverwriteFiles			'pOvw'
#define	pCaseSensitiveNames		'pCSN'
#define	pDefaultBookmarkFont		'pDBF'
#define	pDefaultBookmarkFontSize	'pDBS'
#define	pDefaultTransferFont		'pDTF'
#define	pDefaultTransferFontSize	'pDTS'
#define	pAddTxtSuffixes			'pATS'
#define	pAddHqxSuffixes			'pAHS'
#define	pAddBinSuffixes			'pABS'
#define	pAddICSuffixes			'pAIS'
#define	pEncodedNames			'pEcN'
#define	pUseInternetConfig		'pUIC'
#define	pAllowDuplicateConns		'pADC'
#define	pInfoMacMirror			'pIMM'
#define	pUMichMirror			'pUMM'
#define	pAnarchieEmulation		'pAEm'
#define	pDefaultShortcut		'pDSh'
#define	pMysteryItemsAsFiles		'pMIF'
#define	pDontUseOT			'pDUO'
#define pIgnoreCache			'pIgC'
#define	pWarnInsecurePass		'pWIP'
#define	pWarnCleartextPassSecureServer	'pWCS'
#define	pStrictCheckProtectionLevel	'pSCP'
#define	pForwardableCredentials		'pFCr'
#define	pSendDummyPass			'pSDP'
#define	pNotifyOptions			'pNfO'
#define	pNotifySound			'pNfS'
#define	pNotifyBlinkIcon		'pBli'
#define	pDefaultDownloadMode		'pDDM'
#define	pDirectServerToServer		'pDXf'
#define	pExternalTextEditor		'pETE'
#define	pExternalImageEditor		'pEIE'
#define	pSKeyWithMD5			'pSM5'
#define	pNoADAT				'p!AD'
#define	pNoMACB				'p!MB'
#define	pNoNOOP				'p!NP'
#define	pUNIXLISTMinusAL		'pUL-'
#define	pNoNavServices			'p!NS'
#define	pRetryDelay			'pRDy'
#define	pDontUploadDotFiles		'pDUD'
#define	pNoMDTM				'p!MD'
#define	pFoldersFirstSorting		'pFFS'

/* enumerations for use with app properties */
#define	kFileFormatEnumeration		'FFmt'
#define	eUnknownFileFormat		'Unkn'
#define	eTextFileFormat			'Text'
#define	eWrappedTextFileFormat		'WTxt'
#define	eRawDataFileFormat		'RawD'
#define	eBinHexFileFormat		'BHex'
#define	eMacBinary1FileFormat		'MBn1'
#define	eMacBinary2FileFormat		'MBn2'
#define eMacBinary3FileFormat		'MBn3'
#define	eAppleSingleFileFormat		'ApSg'
#define	eMacHostFileFormat		'MHst'
#define	eAutomaticFileFormat		'tAut'	// must match kTransferAutomatic

#define	kProxyTypeEumeration		'PxTy'
#define	eSiteHostnameProxy		'PxSh'
#define	eUserAfterLogonProxy		'PxUI'
#define	eProxyOpenProxy			'PxOp'
#define	eTransparentProxy		'PxTr'
#define	eUserWithNoLogonProxy		'PxUn'
#define	eProxyidAtHostProxy		'Pxfr'
#define	eUseridAtHostProxyidProxy	'Pxrr'
#define	eUseridAtProxyidAtHostProxy	'Pxrf'

#define	kNotifyOptionsEnumeration	'NfOp'
#define	eNoNotification				'NNon'
#define	eBeepNotification			'NBee'
#define	eSpeakNotification			'NSpk'
#define	eSoundNotification			'NSnd'

#define	kSocksVersionEnumeration	'SkVr'
#define	eSocksVersion4				'Sk40'
#define	eSocksVersion43				'Sk43'
#define	eSocksVersion5				'Sk50'

#define	cTransferWindow		'cFWA'
#define	cHelpWindow		'cFWB'
#define	cTextWindow		'cFWC'
#define	cBookmarkListWindow	'cFWD'
#define	cShortcutWindow		'cFWE'
#define	cTranscriptWindow	'cFWF'
#define	cMediaWindow		'cFWG'

#define	cFirstFWindow		cTransferWindow
#define	cLastFWindow		cMediaWindow
	
#define	pTransferMode		'pTxM'		/* cTransferWindow properties */
#define	pViewOrder		'pVOr'
#define	pHostName		'pHNm'
#define	pUserID			'pUid'
#define	pPassword		'pPwd'
#define	pStartDir		'pSDr'
#define	pWorkDir		'pWDr'
#define	pStatus			'pSta'
#define	pCurrentItem		'pCrI'
#define	pApproxSize		'pASz'
#define	pBytesTransfered	'pBTx'
#define	pElapsedTime		'pElT'
#define	pTransferFormat		'pTFm'
#define	pParentDir		'pPDr'
#define	pAuthenticate		'pAut'
#define	pEncrypt		'pEnc'

#define	pText			'pTxt'		/* cTextWindow, cTranscriptWindow, cHelpWindow properties */
		
//#define	pViewOrder	'pVOr'		/* cBookmarkList, cShortcutWindow properties */
#define	pFileSpec		'pFSp'
//#define	pIsModified	'imod'

#define	kTransferModeEnumeration	'TxMd'	/* pTransferMode enumeration */
#define	kTransferAutomatic	'tAut'
#define	kTransferBinary		'tBin'
#define	kTransferText		'tTxt'

#define	cHostItem		'cFHA'
#define	cHostFile		'cFHB'
#define	cHostDirectory		'cFHC'
#define	cURL			'cFHD'

#define	cFirstHostItemClass	cHostItem
#define	cLastHostItemClass	cURL
	
#define	kHostItemTypeEnumeration	'HtTp'	/* pHostItemType enumeration */
#define	kHostItemFile		'hFil'
#define	kHostItemDirectory	'hDir'
#define	kHostItemLink		'hLnk'
#define	kHostItemUnknown	'hUnk'

#define	kAuthenticationTypeEnumeration	'Auth'	/* pAuthenticationType enumeration */
#define	kAuthCleartextEnum	'aClr'
#define	kAuthKClientEnum	'aKCl'
#define	kAuthGSSEnum		'aGSS'

#define	cFirstHostItemClass	cHostItem
#define	cLastHostItemClass	cURL
	
#define	pHostItemType		'pTyp'	/* cHostItem, cHostFile, cHostDirectory properties */
//#define	pName			'pnam'
#define	pURL			'pURL'
#define	pSize			'pSiz'
#define	pModDate		'pMod'

#define	cBookmark		'cBmk'

//#define	pHostItemType		'pTyp'	/* cBookmark properties */
//#define	pName			'pnam'
#define	pURL			'pURL'
#define	pHostName		'pHNm'
#define	pUserID			'pUid'
#define	pPassword		'pPwd'
#define	pPath			'pPth'
#define	pSize			'pSiz'
#define	pModDate		'pMod'

extern OSErr FetchOpenURL(char *url, AEIdleUPP idleUPP);
extern OSErr FetchPut(FSSpec *fspec, char *url, AEIdleUPP idleUPP);
extern OSErr FetchGet(char *url, FSSpec *fspec, AEIdleUPP idleUPP);
extern OSErr FetchViewFile(char *url, AEIdleUPP idleUPP);
extern OSErr FetchItemExists(char *fname, Boolean *exists, AEIdleUPP idleUPP);
extern OSErr FetchRenameItem(char *oldname, char *newname, AEIdleUPP idleUPP);
extern OSErr FetchCreateDirectory(char *dirname, AEIdleUPP idleUPP);
extern OSErr FetchSendCommand(char *cmd, char *url, AEIdleUPP idleUPP);
extern OSErr FetchGetPreference(DescType propCode, AEDesc *valueDesc, AEIdleUPP idleUPP);
extern OSErr FetchSetPreference(DescType propCode, AEDesc *valueDesc, AEIdleUPP idleUPP);



